// control fan apple macbook i3
// tested on macbook  2009 model
// works on linux

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <syslog.h>

int main(int argc, char **argv) {

	int i;
	int option;
	int limit = 90;

while ((option = getopt(argc, argv, "l:uh")) != -1) {
	switch (option) {
		case 'h':
      puts("help");
      puts("-l limit capacity");
      break;
    case 'l':
			limit = atoi(optarg);
			printf("limit: %d\n", limit);
			break;
		default:                          /* '?' */
      puts("unknown option");
    }
  }

	pid_t pid, sid;
	pid = fork();
	if (pid < 0) {
		exit(EXIT_FAILURE);
	}
	if (pid > 0) {
			exit(EXIT_SUCCESS);
	}

	umask(0);
	sid = setsid();
	if (sid < 0) {
		exit(EXIT_FAILURE);
	}

	if ((chdir("/")) < 0) {
		exit(EXIT_FAILURE);
	}

	close(STDIN_FILENO);
	close(STDOUT_FILENO);
	close(STDERR_FILENO);

	FILE * cb;
	FILE * tempfile;
	FILE * speedfile;
	FILE * man;
	char speed[20];
	int ispeed;
	char temp[6];
	int itemp;
	char LOGNAME[] = "fan-ctl";

	man = fopen("/sys/devices/platform/applesmc.768/fan1_manual", "w");
	fprintf(man, "%d", 1);
	fclose(man);

	void change (int what) {
		cb = fopen("/sys/devices/platform/applesmc.768/fan1_output", "w");
		if (cb == NULL) {
			printf("problem with open\n");
			exit(EXIT_FAILURE);
		}
		fprintf(cb, "%d", what);
		fclose(cb);
		//openlog(LOGNAME, LOG_PID, LOG_USER);
		// syslog(LOG_USER | LOG_INFO, what);
	}

	while (1) {
		tempfile = fopen("/sys/class/thermal/thermal_zone1/temp", "r");
		fgets(temp, 5, tempfile);
		fclose(tempfile);
		itemp = atoi(temp);
		printf("temp: %d\n", itemp);
    
		speedfile = fopen("/sys/class/thermal/thermal_zone1/temp", "r");
		fgets(speed, 5, speedfile);
		fclose(speedfile);
		ispeed = atoi(speed);
		printf("speed: %d\n", ispeed);
    
		if (itemp < 45) {
			ispeed -= 400;
		} else {
			ispeed += 400;
		}
			change(ispeed);
		sleep(30);
	}

	exit(EXIT_SUCCESS);
}


